소스 검색

Use mkit from fastfoo for installation

Alois Mahdal 10 년 전
부모
커밋
93775a243e

+ 9
- 18
Makefile 파일 보기

@@ -3,10 +3,7 @@
3 3
 
4 4
 include config.mk
5 5
 
6
-all: options built.list
7
-
8
-built.list:
9
-	@setup/mk.sh build
6
+all: options build
10 7
 
11 8
 options:
12 9
 	@echo saturnin build options:
@@ -14,27 +11,21 @@ options:
14 11
 	@echo "PREFIX   = ${PREFIX}"
15 12
 
16 13
 build:
17
-	@setup/mk.sh build
18
-
19
-install_manpages: manpages
20
-	@setup/mk.sh install_manpages
21
-
22
-manpages:
23
-	@setup/mk.sh manpages
14
+	@mkit/make build
24 15
 
25
-test: install
26
-	@setup/mk.sh test
16
+manpages: build
17
+	@mkit/make build_manpages
27 18
 
28 19
 clean:
29
-	@setup/mk.sh clean
20
+	@mkit/make clean
30 21
 
31 22
 dist: clean
32
-	@setup/mk.sh dist
23
+	@mkit/make dist
33 24
 
34 25
 install: all
35
-	@setup/mk.sh install
26
+	@mkit/make install
36 27
 
37 28
 uninstall:
38
-	@setup/mk.sh uninstall
29
+	@mkit/make uninstall
39 30
 
40
-.PHONY: all options clean dist install test uninstall
31
+.PHONY: all options clean dist install uninstall

+ 1
- 5
config.mk 파일 보기

@@ -1,7 +1,3 @@
1 1
 VERSION = 0.0.11
2 2
 STAGE = devel
3
-PREFIX = /usr/local
4
-MANPREFIX = ${PREFIX}/share/man
5
-SATURNIN_CONFIG_PATH_LOCAL = /etc/saturnin
6
-SATURNIN_CONFIG_PATH_USER = .saturnin
7
-SATURNIN_CACHE_HOME = .local/share/saturnin
3
+PREFIX=/usr/local

+ 57
- 0
mkit/config.ini 파일 보기

@@ -0,0 +1,57 @@
1
+
2
+[ENV]
3
+
4
+    PROJNAME = saturnin
5
+    PREFIX = /usr
6
+
7
+[lists]
8
+
9
+    group = bin
10
+    group = libexec
11
+    group = share
12
+
13
+    dist = bin
14
+    dist = config.mk
15
+    dist = LICENSE
16
+    dist = Makefile
17
+    dist = mkit
18
+    dist = README
19
+    dist = src
20
+
21
+[modes]
22
+    bin     = 755
23
+    libexec = 755
24
+    share   = 644
25
+
26
+[roots]
27
+    bin     = [ENV:PREFIX]/bin
28
+    libexec = [ENV:PREFIX]/libexec/saturnin
29
+    share   = [ENV:PREFIX]/share/saturnin
30
+    etc     = /etc/saturnin
31
+
32
+[vars]
33
+    __SATURNIN_CACHE_HOME__     = $HOME/.local/share/saturnin
34
+    __SATURNIN_CONFIG_USER__    = $HOME/.saturnin
35
+    __SATURNIN_CONFIG_LOCAL__   = [roots:etc]
36
+    __SATURNIN_LIBEXEC__        = [roots:libexec]
37
+    __SATURNIN_SHARE__          = [roots:share]
38
+    __FFOO_DIR__                = [roots:share]/ffoo
39
+
40
+[files:bin]
41
+    src/bin/saturnin                        = saturnin
42
+
43
+[files:libexec]
44
+    src/libexec/saturnin-czrates            = saturnin-czrates
45
+    src/libexec/saturnin-clip               = saturnin-clip
46
+    src/libexec/saturnin-dmenu              = saturnin-dmenu
47
+    src/libexec/saturnin-iam                = saturnin-iam
48
+    src/libexec/saturnin-conf               = saturnin-conf
49
+    src/libexec/saturnin-ip                 = saturnin-ip
50
+    src/libexec/saturnin-ln                 = saturnin-ln
51
+    src/libexec/saturnin-push               = saturnin-push
52
+    src/libexec/saturnin-revert             = saturnin-revert
53
+    src/libexec/saturnin-watch              = saturnin-watch
54
+    src/libexec/saturnin-www                = saturnin-www
55
+
56
+[files:share]
57
+    src/ffoo/saturnin_www.sh                = ffoo/saturnin_www.sh

setup/mk.sh → mkit/include/build.sh 파일 보기

@@ -1,52 +1,24 @@
1 1
 #!/bin/bash
2
-# saturnin - Smart and ready desktop helper
3
-# See LICENSE file for copyright and license details.
4 2
 
5
-tmp=$(mktemp)
6
-sed -e 's/ = /=/' < config.mk > $tmp
7
-. $tmp
8
-rm -f $tmp
3
+. mkit/include/ini.sh || die "cannot import ini.sh"
9 4
 
10
-bindir=${DESTDIR}${PREFIX}/bin
11
-shrdir=${DESTDIR}${PREFIX}/share/saturnin
12
-lexdir=${DESTDIR}${PREFIX}/libexec/saturnin
13 5
 
14
-list_of_bins() {
15
-    echo bin/saturnin
16
-}
17
-
18
-list_of_lexs() {
19
-    echo libexec/saturnin-czrates
20
-    echo libexec/saturnin-clip
21
-    echo libexec/saturnin-dmenu
22
-    echo libexec/saturnin-iam
23
-    echo libexec/saturnin-conf
24
-    echo libexec/saturnin-ip
25
-    echo libexec/saturnin-ln
26
-    echo libexec/saturnin-push
27
-    echo libexec/saturnin-revert
28
-    echo libexec/saturnin-watch
29
-    echo libexec/saturnin-www
30
-}
31
-
32
-list_of_installed_bins() {
33
-    list_of_bins | sed -e "s/bin/$(sed -e 's/\//\\\//g' <<<$bindir)/"
34
-}
35
-
36
-list_of_installed_lexs() {
37
-    list_of_lexs | sed -e "s/libexec/$(sed -e 's/\//\\\//g' <<<$lexdir)/"
38
-}
39
-
40
-die() {
41
-    for l in "$@"; do echo "$l" >&2; done
42
-    exit 9
43
-}
44
-
45
-list_of_shrs() {
46
-    echo ffoo/saturnin_www.sh
6
+build() {
7
+    #
8
+    # Add meat to all skeletons
9
+    #
10
+    local srcpath
11
+    find src -type f -name '*.skel' \
12
+     | while read srcpath;
13
+       do
14
+           build1 "$srcpath"
15
+       done
47 16
 }
48 17
 
49 18
 build1() {
19
+    #
20
+    # Process one skeleton
21
+    #
50 22
     local srcpath dstpath
51 23
     srcpath=$1
52 24
     dstpath=${srcpath%.skel}
@@ -62,13 +34,21 @@ build1() {
62 34
     echo $dstpath >> built.list
63 35
 }
64 36
 
65
-build() {
66
-    local srcpath
67
-    find -type f -name '*.skel' \
68
-     | while read srcpath;
69
-       do
70
-           build1 "$srcpath"
71
-       done
37
+build_manpages() {
38
+    local manfile mdfile
39
+    if command -v ronn >/dev/null;
40
+    then
41
+        ini lskeys "files:man" \
42
+          | while read manfile;
43
+            do
44
+                mdfile=$manfile.md
45
+                ronn -r $mdfile
46
+                echo $manfile >> built.list
47
+            done
48
+    else
49
+        echo "ronn is not installed"
50
+        return 1
51
+    fi
72 52
 }
73 53
 
74 54
 clean() {
@@ -86,17 +66,10 @@ dist() {
86 66
     # Create distributable tarball
87 67
     #
88 68
     local version=$(get_version)
89
-    local dirname=saturnin-$version
69
+    local dirname=$MKIT_PROJNAME-$version
90 70
     mkdir -p $dirname
91
-    cp -R   bin \
92
-            config.mk \
93
-            ffoo \
94
-            Makefile \
95
-            README \
96
-            LICENSE \
97
-            setup \
98
-            utils \
99
-            $dirname
71
+    local item
72
+    cp -R $(ini values "lists:dist") $dirname
100 73
     sed -i -e "s/^VERSION = .*/VERSION = $version/" $dirname/config.mk
101 74
     tar -cf $dirname.tar $dirname
102 75
     gzip $dirname.tar
@@ -132,29 +105,18 @@ expand_variables() {
132 105
     #
133 106
     # Expand variable values
134 107
     #
135
-    perl -pe "
136
-        s|__SATURNIN_CONFIG_LOCAL__|$SATURNIN_CONFIG_PATH_LOCAL|;
137
-        s|__SATURNIN_CONFIG_USER__|\\\$HOME/$SATURNIN_CONFIG_PATH_USER|;
138
-        s|__SATURNIN_CACHE_HOME__|\\\$HOME/$SATURNIN_CACHE_HOME|;
139
-        s|__SATURNIN_SHARE__|$shrdir|;
140
-        s|__SATURNIN_LIBEXEC__|$lexdir|;
141
-        s|__VERSION__|$(get_version)|;
142
-    "
143
-}
144
-
145
-install() {
146
-    #
147
-    # Install product
148
-    #
149
-    mkdir -vp $bindir \
150
-              $shrdir/ffoo \
151
-              $lexdir
152
-    list_of_bins | xargs cp -vrt $bindir
153
-    list_of_shrs | xargs cp -vrt $shrdir/ffoo
154
-    list_of_lexs | xargs cp -vrt $lexdir
155
-    list_of_installed_bins | xargs chmod -v 755
156
-    list_of_installed_lexs | xargs chmod -v 755
157
-    test -f .autoclean && clean || :
108
+    local script=$(mktemp --tmpdir mkit-tmp.XXXXXXXXXX)
109
+    local varname varvalue
110
+    ini lskeys "vars" \
111
+      | while read varname;
112
+        do
113
+            varvalue="$(ini 1value "vars:$varname" | sed -e 's/\$/\\$/' )"
114
+            echo "s|$varname|$varvalue|;" >> $script
115
+        done
116
+    echo "s|__CODENAME__|$CODENAME|;"     >> $script
117
+    echo "s|__VERSION__|$(get_version)|;" >> $script
118
+    perl -wp $script
119
+    rm $script
158 120
 }
159 121
 
160 122
 get_version() {
@@ -198,6 +160,10 @@ get_version() {
198 160
     # meta-data is to *identify* the code, and provide safe path back
199 161
     # to tree; commit refs are already perfect for that.
200 162
     #
163
+    # FIXME:  The assumpton "if we are in git repo, we can read version
164
+    #         from tags" fails if we are in shallow clone made from
165
+    #         other than a tagged commit.
166
+    #
201 167
     local version=$VERSION
202 168
     local stage=$STAGE
203 169
     if git rev-parse HEAD >&/dev/null;
@@ -227,20 +193,3 @@ get_version() {
227 193
     fi
228 194
     echo $version
229 195
 }
230
-
231
-uninstall() {
232
-    #
233
-    # Uninstall product
234
-    #
235
-    list_of_installed_bins | xargs rm -vf
236
-    rm -vrf $shrdir
237
-    rm -vrf $lexdir
238
-}
239
-
240
-case $1 in
241
-    build|clean|dist|install|install_manpages|manpages|uninstall)
242
-        $1
243
-        ;;
244
-    *)
245
-        echo "usage: $(basename $0) build|clean|dist|install|uninstall" >&2
246
-esac

+ 57
- 0
mkit/include/deploy.sh 파일 보기

@@ -0,0 +1,57 @@
1
+#!/bin/bash
2
+
3
+
4
+get_dst() {
5
+    #
6
+    # Find out target path for src file $2 of group $1
7
+    #
8
+    local grp=$1
9
+    local src=$2
10
+    echo "$(get_root $grp)/$(ini 1value "files:$grp:$src")"
11
+}
12
+
13
+get_root() {
14
+    #
15
+    # Find out target rooot for group $1
16
+    #
17
+    local grp="$1"
18
+    local root=$(ini 1value "roots:$grp")
19
+    test -n "$root" || die "missing in config.ini: roots:$grp"
20
+    echo "$root"
21
+}
22
+
23
+install() {
24
+    #
25
+    # Install product
26
+    #
27
+    local dst group mode src
28
+    ini values "lists:group" \
29
+      | while read group;
30
+        do
31
+            mode=$(ini 1value "modes:$group")
32
+            ini lskeys "files:$group" \
33
+              | while read src;
34
+                do
35
+                    dst=$(get_dst "$group" "$src")
36
+                    command -p install -DTvm $mode $src "$dst"
37
+                done
38
+        done
39
+    test -f .autoclean && clean || :
40
+}
41
+
42
+uninstall() {
43
+    #
44
+    # Uninstall product
45
+    #
46
+    local dst group src
47
+    ini values "lists:group" \
48
+      | while read group;
49
+        do
50
+            ini lskeys "files:$group" \
51
+              | while read src;
52
+                do
53
+                    dst=$(get_dst "$group" "$src")
54
+                    rm -vf "$dst"
55
+                done
56
+        done
57
+}

+ 139
- 0
mkit/include/ini.sh 파일 보기

@@ -0,0 +1,139 @@
1
+#!/bin/bash
2
+
3
+ini() {
4
+    #
5
+    # do ini operation
6
+    #
7
+    local op=$1
8
+    local arg=$2
9
+    local fn
10
+    local limit=_ini_cat
11
+    case $op in
12
+        lskeys) fn=_ini_lskeys   ;;
13
+        sec)    fn=_ini_grepsec  ;;
14
+        values) fn=_ini_greppath ;;
15
+        1value) fn=_ini_greppath; limit="tail -1" ;;
16
+        *)      die "incorrect use of \`ini()\`"
17
+    esac
18
+    _ini_cached | $fn $arg | $limit
19
+}
20
+
21
+_ini_cached() {
22
+    #
23
+    # Load ini file to our cache (RAM disk) and cat it
24
+    #
25
+    # User should set MKIT_INI_CACHE to a ram-based file
26
+    # if mktemp cannot be relied upon.
27
+    #
28
+    if test -z "$_MKIT_INI_CACHED";
29
+    then
30
+        MKIT_INI_CACHE=${MKIT_INI_CACHE:-$(mktemp)}
31
+        _MKIT_INI_CACHED=$MKIT_INI_CACHE
32
+        test -r $MKIT_INI || die "cannot read MKIT_INI: $MKIT_INI"
33
+        cp $MKIT_INI $_MKIT_INI_CACHED
34
+    fi
35
+    cat $_MKIT_INI_CACHED
36
+}
37
+
38
+_ini_cat() {
39
+    #
40
+    # A no-op for text stream
41
+    #
42
+    while read line;
43
+    do
44
+        printf -- "%s\n" "$line"
45
+    done
46
+}
47
+
48
+_ini_expand() {
49
+    #
50
+    # Expand reference value (prefix only)
51
+    #
52
+    local line suffix ref value
53
+    while read line;                        # [foo:bar]/path
54
+    do
55
+        suffix="${line#\[*\]}"              # /path
56
+        ref="${line%$suffix}"               # [foo:bar]
57
+        ref="${ref%\]}"                     # [foo:bar
58
+        ref="${ref#\[}"                     # foo:bar
59
+        value="$(ini 1value "$ref")"        # foo_bar_value
60
+        printf -- "%s\n" "$value$suffix"    # foo_bar_value/path
61
+    done
62
+}
63
+
64
+_ini_grepkey() {
65
+    #
66
+    # Read key from a section
67
+    #
68
+    local wnt=$1
69
+    grep '.' \
70
+      | grep -v '\s*#' \
71
+      | sed -e 's/ *= */=/; s/ +$//; s/^//;' \
72
+      | grep -e "^$wnt=" \
73
+      | cut -d= -f2- \
74
+      | _ini_maybe_expand
75
+}
76
+
77
+_ini_greppath() {
78
+    #
79
+    # Read key from the right section
80
+    #
81
+    # E.g. `files:share:my/lib.sh` should read
82
+    #
83
+    #     [files:share]
84
+    #         my/lib.sh   = proj/my/lib.sh
85
+    #
86
+    local wnt=$1
87
+    local wntkey=${wnt##*:}
88
+    local wntsec=${wnt%:$wntkey}
89
+    if test "$wntsec" = 'ENV';
90
+    then
91
+        local override="${!wntkey}"
92
+        if test -n "$override";
93
+        then
94
+            echo "$override"
95
+            return
96
+        fi
97
+    fi
98
+    _ini_grepsec $wntsec | _ini_grepkey $wntkey
99
+}
100
+
101
+_ini_grepsec() {
102
+    #
103
+    # Read one INI section
104
+    #
105
+    local wnt=$1
106
+    local ok=false
107
+    grep '.' \
108
+      | grep -v '\s*#' \
109
+      | while read line;
110
+        do
111
+            case "$line" in
112
+                \[$wnt\]) ok=true;  continue ;;
113
+                \[*\])    ok=false; continue ;;
114
+            esac
115
+            $ok || continue
116
+            printf -- "%s\n" "$line"
117
+        done \
118
+      | sed -e 's/ *= */=/; s/ +$//; s/^//;'
119
+}
120
+
121
+_ini_lskeys() {
122
+    #
123
+    # List keys from a section
124
+    #
125
+    local sct=$1
126
+    _ini_grepsec $sct | cut -d= -f1 | sort | uniq
127
+}
128
+
129
+_ini_maybe_expand() {
130
+    #
131
+    # Decide whether or not to expand
132
+    #
133
+    if test $MKIT_INI_EXPAND -gt 0;
134
+    then
135
+        MKIT_INI_EXPAND=$(( $MKIT_INI_EXPAND - 1 )) _ini_expand
136
+    else
137
+        _ini_cat
138
+    fi
139
+}

+ 41
- 0
mkit/include/mkit.sh 파일 보기

@@ -0,0 +1,41 @@
1
+#!/bin/bash
2
+
3
+. mkit/include/build.sh  || die "cannot import ini.sh"
4
+. mkit/include/deploy.sh || die "cannot import ini.sh"
5
+. mkit/include/ini.sh    || die "cannot import ini.sh"
6
+
7
+MKIT_INI=${MKIT_INI:-mkit/config.ini}
8
+MKIT_INI_EXPAND=2
9
+MKIT_PROJNAME=$(ini 1value "ENV:PROJNAME")
10
+
11
+configure() {
12
+    #
13
+    # Load variables fdom config.mk
14
+    #
15
+    tmp=$(mktemp)
16
+    sed -e 's/ = /=/' < config.mk > $tmp
17
+    . $tmp
18
+    rm -f $tmp
19
+    PREFIX="$(readlink -f "$PREFIX")"
20
+}
21
+
22
+die() {
23
+    #
24
+    # Exit with message and non-zero exit status
25
+    #
26
+    echo "$@" >&2
27
+    exit 4
28
+}
29
+
30
+route() {
31
+    #
32
+    # Call correct function based on $1
33
+    #
34
+    case $1 in
35
+        build|build_manpages|clean|dist|install|uninstall)
36
+            $1
37
+            ;;
38
+        *)
39
+            echo "usage: $(basename $0) build|clean|dist|install|uninstall" >&2
40
+    esac
41
+}

+ 13
- 0
mkit/make 파일 보기

@@ -0,0 +1,13 @@
1
+#!/bin/bash
2
+# mkit - simple install helper
3
+# See LICENSE file for copyright and license details.
4
+
5
+die() {
6
+    echo "$@" && exit 9
7
+}
8
+
9
+. mkit/include/mkit.sh || die "this must be run from project root"
10
+
11
+configure
12
+
13
+route "$@"

bin/saturnin.skel → src/bin/saturnin.skel 파일 보기


ffoo/saturnin_www.sh → src/ffoo/saturnin_www.sh 파일 보기


libexec/saturnin-clip → src/libexec/saturnin-clip 파일 보기


libexec/saturnin-conf → src/libexec/saturnin-conf 파일 보기


libexec/saturnin-czrates → src/libexec/saturnin-czrates 파일 보기


libexec/saturnin-dmenu → src/libexec/saturnin-dmenu 파일 보기


libexec/saturnin-iam → src/libexec/saturnin-iam 파일 보기


libexec/saturnin-ip → src/libexec/saturnin-ip 파일 보기


libexec/saturnin-ln → src/libexec/saturnin-ln 파일 보기


libexec/saturnin-push → src/libexec/saturnin-push 파일 보기


libexec/saturnin-revert → src/libexec/saturnin-revert 파일 보기


libexec/saturnin-watch → src/libexec/saturnin-watch 파일 보기


libexec/saturnin-www → src/libexec/saturnin-www 파일 보기